'2009 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports System.ServiceModel
Imports Microsoft.ServiceBus
Imports ServiceModelEx


<ServiceContract> _
Friend Interface IMyEvents
   <OperationContract(IsOneWay := True)> _
   Sub OnEvent1()

   <OperationContract(IsOneWay := True)> _
   Sub OnEvent2(ByVal number As Integer)

   <OperationContract(IsOneWay := True)> _
   Sub OnEvent3(ByVal number As Integer, ByVal text As String)
End Interface

Partial Friend Class MySubscriberForm
	Inherits Form
	Implements IMyEvents
   Private Enum EventType
	  Event1 = 1
	  Event2 = 2
	  Event3 = 4
	  AllEvents = Event1 Or Event2 Or Event3
   End Enum

   Private m_Host As EventRelayHost

   Public Sub New()
	  InitializeComponent()

	  Dim baseAddress As String = "sb://MySolution/servicebus.windows.net/"

	  m_Host = New EventRelayHost(GetType(MySubscriber),baseAddress)

	  m_Host.ConfigureAnonymousMessageSecurity("MyserviceCert")
	  m_Host.SetServiceBusPassword("Get this from some login dialog box")
   End Sub

   Private Function GetSelectedEvent() As EventType
	  If m_Event1RadioButton.Checked Then
		 Return EventType.Event1
	  End If
	  If m_Event2RadioButton.Checked Then
		 Return EventType.Event2
	  End If
	  If m_Event3RadioButton.Checked Then
		 Return EventType.Event3
	  End If
	  If m_AllEventsRadioButton.Checked Then
		 Return EventType.AllEvents
	  End If
	  Throw New InvalidOperationException()
   End Function
   Public Sub OnEvent1() Implements IMyEvents.OnEvent1
	  MessageBox.Show("OnEvent1()","MySubscriber")
   End Sub
   Public Sub OnEvent2(ByVal number As Integer) Implements IMyEvents.OnEvent2
	  MessageBox.Show("OnEvent2()","MySubscriber")
   End Sub
   Public Sub OnEvent3(ByVal number As Integer, ByVal text As String) Implements IMyEvents.OnEvent3
	  MessageBox.Show("OnEvent3()","MySubscriber")
   End Sub
   Private Overloads Sub OnClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing
	  m_Host.Unsubscribe()
   End Sub
   Private Sub OnSubscribe(ByVal sender As Object, ByVal e As EventArgs) Handles m_SubscribeButtton.Click
	  Dim eventToSubscribe As EventType = GetSelectedEvent()

	  Select Case eventToSubscribe
		 Case EventType.Event1
			m_Host.Subscribe(GetType(IMyEvents),"OnEvent1")
			Exit Select
		 Case EventType.Event2
			m_Host.Subscribe(GetType(IMyEvents),"OnEvent2")
			Exit Select
		 Case EventType.Event3
			m_Host.Subscribe(GetType(IMyEvents),"OnEvent3")
			Exit Select
		 Case EventType.AllEvents
			m_Host.Subscribe(GetType(IMyEvents))
			Exit Select
		 Case Else
			Throw New InvalidOperationException("Unknown event type")
	  End Select
   End Sub
   Private Sub OnUnsubscribe(ByVal sender As Object, ByVal e As EventArgs) Handles m_UnsubscribeButton.Click
	  Dim eventToSubscribe As EventType = GetSelectedEvent()
	  Select Case eventToSubscribe
		 Case EventType.Event1
			m_Host.Unsubscribe(GetType(IMyEvents),"OnEvent1")
			Exit Select
		 Case EventType.Event2
			m_Host.Unsubscribe(GetType(IMyEvents),"OnEvent2")
			Exit Select
		 Case EventType.Event3
			m_Host.Unsubscribe(GetType(IMyEvents),"OnEvent3")
			Exit Select
		 Case EventType.AllEvents
			m_Host.Unsubscribe(GetType(IMyEvents))
			Exit Select
		 Case Else
			Throw New InvalidOperationException("Unknown event type")
	  End Select
   End Sub
End Class