'2009 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.ObjectModel
Imports System.ServiceModel
Imports System.Security.Cryptography.X509Certificates
Imports System.Diagnostics
Imports System.Net
Imports System.Security.Principal
Imports System.ServiceModel.Description
Imports System.ServiceModel.Security

Namespace ServiceModelEx
    Public Module SecurityHelper
        <System.Runtime.CompilerServices.Extension()> _
        Public Sub ImpersonateAll(ByVal host As ServiceHostBase)
            If host.State = CommunicationState.Opened Then
                Throw New InvalidOperationException("Host is already opened")
            End If
            host.Authorization.ImpersonateCallerForAllOperations = True
            host.Description.ImpersonateAll()
        End Sub
        <System.Runtime.CompilerServices.Extension()> _
        Public Sub ImpersonateAll(ByVal description As ServiceDescription)
            For Each endpoint As ServiceEndpoint In description.Endpoints
                If endpoint.Contract.Name = "IMetadataExchange" Then
                    Continue For
                End If
                For Each operation As OperationDescription In endpoint.Contract.Operations
                    Dim attribute As OperationBehaviorAttribute = operation.Behaviors.Find(Of OperationBehaviorAttribute)()
                    If attribute IsNot Nothing Then
                        If attribute.Impersonation = ImpersonationOption.NotAllowed Then
                            Trace.WriteLine("Overriding impersonation setting of " & endpoint.Contract.Name & "." & operation.Name)
                        End If
                        attribute.Impersonation = ImpersonationOption.Required
                        Continue For
                    End If
                Next operation
            Next endpoint
        End Sub
    End Module
End Namespace