'2009 IDesign Inc. 
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports System.ServiceModel
Imports Microsoft.ServiceBus


<ServiceContract> _
Friend Interface IMyEvents
   <OperationContract(IsOneWay := True)> _
   Sub OnEvent1()

   <OperationContract(IsOneWay := True)> _
   Sub OnEvent2(ByVal number As Integer)

   <OperationContract(IsOneWay := True)> _
   Sub OnEvent3(ByVal number As Integer, ByVal text As String)
End Interface

Partial Friend Class MySubscriberForm
	Inherits Form
	Implements IMyEvents
   Private Enum EventType
	  Event1 = 1
	  Event2 = 2
	  Event3 = 4
	  AllEvents = Event1 Or Event2 Or Event3
   End Enum

   Private m_HostEvent1 As ServiceHost
   Private m_HostEvent2 As ServiceHost
   Private m_HostEvent3 As ServiceHost

   Public Sub New()
	  InitializeComponent()
   End Sub

   Private Function GetSelectedEvent() As EventType
	  If m_Event1RadioButton.Checked Then
		 Return EventType.Event1
	  End If
	  If m_Event2RadioButton.Checked Then
		 Return EventType.Event2
	  End If
	  If m_Event3RadioButton.Checked Then
		 Return EventType.Event3
	  End If
	  If m_AllEventsRadioButton.Checked Then
		 Return EventType.AllEvents
	  End If
	  Throw New InvalidOperationException()
   End Function
   Public Sub OnEvent1() Implements IMyEvents.OnEvent1
	  MessageBox.Show("OnEvent1()","MySubscriber")
   End Sub
   Public Sub OnEvent2(ByVal number As Integer) Implements IMyEvents.OnEvent2
	  MessageBox.Show("OnEvent2()","MySubscriber")
   End Sub
   Public Sub OnEvent3(ByVal number As Integer, ByVal text As String) Implements IMyEvents.OnEvent3
	  MessageBox.Show("OnEvent3()","MySubscriber")
   End Sub
   Private Overloads Sub OnClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing
	  m_AllEventsRadioButton.Checked = True
	  OnUnsubscribe(Me,EventArgs.Empty)
   End Sub
   Private Sub OnSubscribe(ByVal sender As Object, ByVal e As EventArgs) Handles m_SubscribeButtton.Click
	  Dim eventToSubscribe As EventType = GetSelectedEvent()

	  Dim binding As New NetEventRelayBinding()

	  Dim baseAddress As New Uri("sb://MySolution/servicebus.windows.net/IMyEvents/")

	  If (eventToSubscribe And EventType.Event1) = EventType.Event1 Then
		 If m_HostEvent1 Is Nothing Then
			m_HostEvent1 = New ServiceHost(GetType(MySubscriber),baseAddress)
			m_HostEvent1.AddServiceEndpoint(GetType(IMyEvents),binding,"OnEvent1")
			m_HostEvent1.Open()
		 End If
	  End If
	  If (eventToSubscribe And EventType.Event2) = EventType.Event2 Then
		 If m_HostEvent2 Is Nothing Then
			m_HostEvent2 = New ServiceHost(GetType(MySubscriber),baseAddress)
			m_HostEvent2.AddServiceEndpoint(GetType(IMyEvents),binding,"OnEvent2")
			m_HostEvent2.Open()
		 End If
	  End If
	  If (eventToSubscribe And EventType.Event3) = EventType.Event3 Then
		 If m_HostEvent3 Is Nothing Then
			m_HostEvent3 = New ServiceHost(GetType(MySubscriber),baseAddress)
			m_HostEvent3.AddServiceEndpoint(GetType(IMyEvents),binding,"OnEvent3")
			m_HostEvent3.Open()
		 End If
	  End If
   End Sub
   Private Sub OnUnsubscribe(ByVal sender As Object, ByVal e As EventArgs) Handles m_UnsubscribeButton.Click
	  Dim eventToSubscribe As EventType = GetSelectedEvent()

	  If (eventToSubscribe And EventType.Event1) = EventType.Event1 Then
		 If m_HostEvent1 IsNot Nothing Then
			m_HostEvent1.Close()
			m_HostEvent1 = Nothing
		 End If
	  End If
	  If (eventToSubscribe And EventType.Event2) = EventType.Event2 Then
		 If m_HostEvent2 IsNot Nothing Then
			m_HostEvent2.Close()
			m_HostEvent2 = Nothing
		 End If
	  End If
	  If (eventToSubscribe And EventType.Event3) = EventType.Event3 Then
		 If m_HostEvent3 IsNot Nothing Then
			m_HostEvent3.Close()
			m_HostEvent3 = Nothing
		 End If
	  End If
   End Sub
End Class